#ifndef frb_window_H
#define frb_window_H

/* A frb_window_t is a box (axis-aligned rectangle) on the plotting plane. */
/* Last edited on 2005-01-16 15:04:35 by stolfi */
/* Copyright  2005 Universidade Estadual de Campinas. See note at end of file. */

#include <frb_types.h>

typedef
   struct frb_window_t { frb_range_t r[2]; } frb_window_t;

bool frb_window_is_empty ( frb_window_t *w );
  /*
    TRUE if {w} is empty or reduces to a single point. */

frb_window_t frb_window_join ( frb_window_t *w1, frb_window_t *w2 );
  /*
    The smallest box that contains {w1} and {w2}. */

frb_window_t frb_window_expand ( frb_window_t *w, double rel );
  /*
    Enlarges {w} on all four sides by {rel} times its maximum extent. */

frb_window_t frb_window_read( FILE *rd );
  /*
     Reads a window from {rd}. */

#endif
/* COPYRIGHT AND AUTHORSHIP NOTICE

  Copyright  2005 Universidade Estadual de Campinas (UNICAMP).
  Created by Helena C. G. Leito and Jorge Stolfi in 1995--2005.
  
  This source file can be freely distributed, used, and modified,
  provided that this copyright and authorship notice is preserved in
  all copies, and that any modified versions of this file are clearly
  marked as such.
  
  This software has NO WARRANTY of correctness or applicability for
  any purpose. Neither the authors nor their employers shall be held
  responsible for any losses or damages that may result from its use.

  END OF NOTICE */
